package cn.jlsxwkj.moudles.userlist;

import cn.dev33.satoken.stp.StpUtil;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import javax.security.auth.login.AccountException;
import javax.security.auth.login.FailedLoginException;
import javax.security.auth.login.LoginException;

/**
 * @author zh
 */
@RestController
@RequestMapping(("/user/"))
public class UserListController {

    @Resource
    private UserListService userListService;

    @PostMapping("/login")
    public String login(@RequestParam String userName,
                          @RequestParam String userPassword) throws LoginException {
        UserList userList = userListService.checkUser(userName, userPassword);
        if (userList != null) {
            if (!StpUtil.isLogin()) {
                String userId = userList.getUserId();
                StpUtil.login(userId);
                return "登录成功";
            }
            throw new LoginException("请勿重复登录");
        }
        throw new FailedLoginException("用户未注册/密码错误");
    }

    @PostMapping("/auth")
    public String auth(@RequestParam String userName,
                        @RequestParam String userPassword) throws AccountException {
        if (userListService.checkUser(userName, userPassword) != null) {
            throw new AccountException("用户已注册, 请勿重复注册");
        }
        if (userListService.authUser(userName, userPassword) > 0) {
            return "注册成功";
        }
        throw new AccountException("注册失败");
    }

    @GetMapping("/logout")
    public String logout() {
        StpUtil.logout();
        return "登出成功";
    }
}
